// i8012W_MagicScan_ISR_Cplusplus.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "..\lib\pac_i8012W.h"
#pragma comment(lib,"..\\lib\\pac_i8012w.lib")
short FIFOData[10000],caldata[10000];
float fval[10000];
short readFIFOcnt;
unsigned long samplerate,realrate,cnt=0,requiredata=2000,total=0,isrcnt=0;
char flag=0;
void __stdcall ISR(int slot);

int _tmain(int argc, _TCHAR* argv[])
{
	int i,slot=-1,ret,chcnt,gain,type;
	int ext_source=-1;
	for(i=0;i<8;i++)
	{
		ret=pac_i8012W_Init(i);
		if(ret==0)
		{
			slot=i;
			printf(" Find I-9012 on slot %d!!\n",slot);
			break;
		}
	}
	if(slot==-1)
	{
		printf(" No I-9012 on Backplane\n");
		getchar();
		return 0;
	}
	printf(" Select AI range : \n");
	printf(" 0 : +/- 5V\n");
	printf(" 1 : +/-10V\n");
	scanf("%d",&gain);

	printf(" Input scan channel : 1~8\n");
	scanf("%d",&chcnt);

	printf(" Select Trigger mode : \n");
	printf(" 0 : Internal Trigger\n");
	printf(" 1 : External Trigger\n");
	scanf("%d",&type);
	if(type==1)
	{
		printf(" Select External Source : \n");
		printf(" 0 : Trig-Output Pin\n");
		printf(" 1 : Other device\n");
		scanf("%d",&ext_source);
		if(ext_source==0)
		{
			printf(" Input sample rate : 20~200000 Hz\n");
			scanf("%lu",&samplerate);
		}
		else
		{
			samplerate=0;
		}
		printf(" Please make sure the External signal is connected with Trig-Input Pin \n Then press any key to continue \n");
		getchar();
	}
	else
	{
		printf(" Input sample rate : 20~200000 Hz\n");
		scanf("%lu",&samplerate);
	}

	pac_i8012W_ConfigMagicScan(slot,gain,chcnt,type,samplerate,&realrate);
	printf("real sample rate %lu\n",realrate);

	printf(" Input number of require data : 1~10000\n");
	scanf("%ld",&requiredata);

	ret=pac_i8012W_InstallMagicScanISR(slot,ISR,2);
	if(type==1)
	{
		if(ext_source==0)
		{
			pac_i8012W_Enable_TrigOut(slot);
		}
		else
		{
			printf("Onput external signal and press any key to continue\n");
			getchar();
		}
	}
	pac_i8012W_StartMagicScan(slot);
	total=0;
	flag=1;
	while(flag)
	{
		printf("Total read count T_%lu I_%lu R_%d\r",total,isrcnt,ret);
		Sleep(100);
	}
	if(type==1)
		if(ext_source==0)
			pac_i8012W_Disable_TrigOut(slot);
	pac_i8012W_UnInstallMagicScanISR(slot);
	for(cnt=0;cnt<requiredata;cnt++)
	{
		pac_i8012W_CalibrationHEX(slot,cnt%chcnt,gain,FIFOData[cnt],&caldata[cnt]);
		pac_i8012W_CalibrationFloat(slot,cnt%chcnt,gain,FIFOData[cnt],&fval[cnt]);
	}
	for(i=0;i<requiredata;i++)
	{
		printf("CH_%d HEX_%X Float_%2.3f ",i%chcnt,caldata[i],fval[i]);
		if(i%chcnt==chcnt-1)
			printf("\n");
	}

	getchar();
	getchar();
	return 0;
}

void __stdcall ISR(int slot)
{
	short ret;
	int i;
	short readCnt=0;
	isrcnt++;
	ret= pac_i8012W_ReadFIFO_ISR(slot,FIFOData+total,&readFIFOcnt);
	pac_i8012W_ClearINT(slot);
	if(ret==FIFO_FULL)
	{
		printf("FIFO Full!!!Total read count %lu \n",total);
		pac_i8012W_StopMagicScan(slot);
		flag=0;
	}
	else if(ret==NoError)
	{
		total+=readFIFOcnt;
		if(total>=requiredata)
		{
			pac_i8012W_StopMagicScan(slot);
			flag=0;
		}
	}
	return;
}