// i8012W_Multi_Modules_Scan_Cplusplus.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "..\lib\pac_i8012W.h"
#pragma comment(lib,"..\\lib\\pac_i8012w.lib")

short FIFOData[8][10000],caldata[8][10000];
float fval[8][10000];
char Allflag=0,modulecnt=0,flag[8]={0};
unsigned long requiredata=2000,total[8]={0,0,0,0,0,0,0,0};

HANDLE priority[8];
DWORD NonBlockslot0(void);
DWORD NonBlockslot1(void);
DWORD NonBlockslot2(void);
DWORD NonBlockslot3(void);
DWORD NonBlockslot4(void);
DWORD NonBlockslot5(void);
DWORD NonBlockslot6(void);
DWORD NonBlockslot7(void);


typedef DWORD (*NonBlock) ();

NonBlock ReadFIFO[]={NonBlockslot0,NonBlockslot1,NonBlockslot2,NonBlockslot3,NonBlockslot4,NonBlockslot5,NonBlockslot6,NonBlockslot7};

int _tmain(int argc, _TCHAR* argv[])
{
	int i,j,slot[8]={-1,-1,-1,-1,-1,-1,-1,-1},ret,chcnt,gain,type;
	int ext_source=-1;
	int MasterSlot=-1;
	unsigned long samplerate,realrate,cnt=0;
	char gainstr[2][10]={"+/- 5V","+/-10V"},trigstr[2][20]={"Internal trig","External trig"};
	for(i=0;i<8;i++)
	{
		ret=pac_i8012W_Init(i);
		if(ret==0)
		{
			slot[i]=i;
			printf(" Find I-9012 on slot %d!!\n",slot[i]);
			modulecnt|=(1<<i);
		}
	}
	if(modulecnt==0)
	{
		printf(" No I-9012 on Backplane\n");
		getchar();
		return 0;
	}
	printf(" Select AI range : \n");
	printf(" 0 : +/- 5V\n");
	printf(" 1 : +/-10V\n");
	scanf("%d",&gain);

	printf(" Input scan channel : 1~8\n");
	scanf("%d",&chcnt);

	printf(" Trigger mode : External Trigger only\n");
	type=1;

	printf(" Select External Source : \n");
	printf(" 0 : Trig-Output Pin\n");
	printf(" 1 : Other device\n");
	scanf("%d",&ext_source);
	if(ext_source==0)
	{
		printf(" Input sample rate : 20~200000 Hz\n");
		scanf("%lu",&samplerate);
		printf(" Input Master Slot : \n");
		for(i=0;i<8;i++)
		{
			if(slot[i]!=-1)
			{
				printf("%d = Slot %d \n",i,i);
			}
		}
		scanf("%d",&MasterSlot);
	}
	else
	{
		samplerate=0;
	}
	printf(" Please make sure the External signal is connected with Trig-Input Pin \n Then press any key to continue \n");
	getchar();

	printf(" Input number of require data : 1~10000\n");
	scanf("%ld",&requiredata);

	for(i=0;i<8;i++)
	{
		if(slot[i]!=-1)
		{
			pac_i8012W_ConfigMagicScan(slot[i],gain,chcnt,type,samplerate,&realrate);
			printf("slot %d %s ch count %d %s real rate %lu\n",slot[i],gainstr[gain],chcnt,trigstr[type],realrate);
			pac_i8012W_StartMagicScan(slot[i]);
			total[i]=0;
			priority[i] = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)ReadFIFO[i], 0, 0, NULL);
			SetThreadPriority(priority[i], 10);
		}
		Sleep(10);
	}

	if(ext_source==0)
	{
		pac_i8012W_Enable_TrigOut(MasterSlot);
	}
	else
	{
		printf("Onput external signal and press any key to continue\n");
		getchar();
	}


	while(1)
	{
		for(i=0;i<8;i++)
		{
			if(slot[i]!=-1)
			{
				if(flag[i]==1)
				{
					Allflag|=(flag[i]<<i);
				}
				else if(flag[i]==-1)
				{
					printf("Slot %d FIFO Full!!\n",i);
					modulecnt^=(1<<i);
					slot[i]=0;
					CloseHandle(priority[i]);
				}
			}
		}
		if(modulecnt!=Allflag)
		{
			for(i=0;i<8;i++)
			{
				if(slot[i]!=-1)
				{
					printf("S_%d T_%lu ",i,total[i]);
				}
			}
			printf("\r");
		}
		else
		{
			for(i=0;i<8;i++)
			{
				if(slot[i]!=-1)
				{
					CloseHandle(priority[i]);
				}
			}
			break;
		}
	}
	if(ext_source==0)
	{
		pac_i8012W_Disable_TrigOut(MasterSlot);
	}
	for(i=0;i<8;i++)
	{
		if(slot[i]!=-1)
		{
			for(cnt=0;cnt<requiredata;cnt++)
			{
				pac_i8012W_CalibrationHEX(slot[i],cnt%chcnt,gain,FIFOData[i][cnt],&caldata[i][cnt]);
				pac_i8012W_CalibrationFloat(slot[i],cnt%chcnt,gain,FIFOData[i][cnt],&fval[i][cnt]);
			}
		}
	}
	printf("Press any key to show AI data\n");
	getchar();
	for(i=0;i<8;i++)
	{
		if(slot[i]!=-1)
		{
			for(j=0;j<requiredata;j++)
			{
				printf("Raw_%X HEX_%X Float_%2.3f ",FIFOData[i][j],caldata[i][j],fval[i][j]);
				if(j%chcnt==chcnt-1)
					printf("\n");
			}
		}
		printf("\n");
	}

	getchar();
	getchar();
	return 0;
}

DWORD NonBlockslot0(void)
{
	int slot=0,ret;
	short readFIFOcnt;
	total[slot]=0;
	for(;;)
	{
		Sleep(1);
		ret=pac_i8012W_Read_FIFO_NonBlock(slot,FIFOData[slot]+total[slot],requiredata-total[slot],&readFIFOcnt);
		if(ret==FIFO_FULL)
		{
			pac_i8012W_StopMagicScan(slot);
			flag[slot]=-1;
			return 0;
		}
		else if(ret==NoError)
		{
			total[slot]+=readFIFOcnt;
			if(total[slot]>=requiredata)
			{
				pac_i8012W_StopMagicScan(slot);
				flag[slot]=1;
				return 0;
			}
		}
	}
	return 0;
}
DWORD NonBlockslot1(void)
{
	int slot=1,ret;
	short readFIFOcnt;
	total[slot]=0;
	for(;;)
	{
		Sleep(1);
		ret=pac_i8012W_Read_FIFO_NonBlock(slot,FIFOData[slot]+total[slot],requiredata-total[slot],&readFIFOcnt);
		if(ret==FIFO_FULL)
		{
			pac_i8012W_StopMagicScan(slot);
			flag[slot]=-1;
			return 0;
		}
		else if(ret==NoError)
		{
			total[slot]+=readFIFOcnt;
			if(total[slot]>=requiredata)
			{
				pac_i8012W_StopMagicScan(slot);
				flag[slot]=1;
				return 0;
			}
		}
	}
	return 0;
}
DWORD NonBlockslot2(void)
{
	int slot=2,ret;
	short readFIFOcnt;
	total[slot]=0;
	for(;;)
	{
		Sleep(1);
		ret=pac_i8012W_Read_FIFO_NonBlock(slot,FIFOData[slot]+total[slot],requiredata-total[slot],&readFIFOcnt);
		if(ret==FIFO_FULL)
		{
			pac_i8012W_StopMagicScan(slot);
			flag[slot]=-1;
			return 0;
		}
		else if(ret==NoError)
		{
			total[slot]+=readFIFOcnt;
			if(total[slot]>=requiredata)
			{
				pac_i8012W_StopMagicScan(slot);
				flag[slot]=1;
				return 0;
			}
		}
	}
	return 0;
}
DWORD NonBlockslot3(void)
{
	int slot=3,ret;
	short readFIFOcnt;
	total[slot]=0;
	for(;;)
	{
		Sleep(1);
		ret=pac_i8012W_Read_FIFO_NonBlock(slot,FIFOData[slot]+total[slot],requiredata-total[slot],&readFIFOcnt);
		if(ret==FIFO_FULL)
		{
			pac_i8012W_StopMagicScan(slot);
			flag[slot]=-1;
			return 0;
		}
		else if(ret==NoError)
		{
			total[slot]+=readFIFOcnt;
			if(total[slot]>=requiredata)
			{
				pac_i8012W_StopMagicScan(slot);
				flag[slot]=1;
				return 0;
			}
		}
	}
	return 0;
}
DWORD NonBlockslot4(void)
{
	int slot=4,ret;
	short readFIFOcnt;
	total[slot]=0;
	for(;;)
	{
		Sleep(1);
		ret=pac_i8012W_Read_FIFO_NonBlock(slot,FIFOData[slot]+total[slot],requiredata-total[slot],&readFIFOcnt);
		if(ret==FIFO_FULL)
		{
			pac_i8012W_StopMagicScan(slot);
			flag[slot]=-1;
			return 0;
		}
		else if(ret==NoError)
		{
			total[slot]+=readFIFOcnt;
			if(total[slot]>=requiredata)
			{
				pac_i8012W_StopMagicScan(slot);
				flag[slot]=1;
				return 0;
			}
		}
	}
	return 0;
}
DWORD NonBlockslot5(void)
{
	int slot=5,ret;
	short readFIFOcnt;
	total[slot]=0;
	for(;;)
	{
		Sleep(1);
		ret=pac_i8012W_Read_FIFO_NonBlock(slot,FIFOData[slot]+total[slot],requiredata-total[slot],&readFIFOcnt);
		if(ret==FIFO_FULL)
		{
			pac_i8012W_StopMagicScan(slot);
			flag[slot]=-1;
			return 0;
		}
		else if(ret==NoError)
		{
			total[slot]+=readFIFOcnt;
			if(total[slot]>=requiredata)
			{
				pac_i8012W_StopMagicScan(slot);
				flag[slot]=1;
				return 0;
			}
		}
	}
	return 0;
}
DWORD NonBlockslot6(void)
{
	int slot=6,ret;
	short readFIFOcnt;
	total[slot]=0;
	for(;;)
	{
		Sleep(1);
		ret=pac_i8012W_Read_FIFO_NonBlock(slot,FIFOData[slot]+total[slot],requiredata-total[slot],&readFIFOcnt);
		if(ret==FIFO_FULL)
		{
			pac_i8012W_StopMagicScan(slot);
			flag[slot]=-1;
			return 0;
		}
		else if(ret==NoError)
		{
			total[slot]+=readFIFOcnt;
			if(total[slot]>=requiredata)
			{
				pac_i8012W_StopMagicScan(slot);
				flag[slot]=1;
				return 0;
			}
		}
	}
	return 0;
}
DWORD NonBlockslot7(void)
{
	int slot=7,ret;
	short readFIFOcnt;
	total[slot]=0;
	for(;;)
	{
		Sleep(1);
		ret=pac_i8012W_Read_FIFO_NonBlock(slot,FIFOData[slot]+total[slot],requiredata-total[slot],&readFIFOcnt);
		if(ret==FIFO_FULL)
		{
			pac_i8012W_StopMagicScan(slot);
			flag[slot]=-1;
			return 0;
		}
		else if(ret==NoError)
		{
			total[slot]+=readFIFOcnt;
			if(total[slot]>=requiredata)
			{
				pac_i8012W_StopMagicScan(slot);
				flag[slot]=1;
				return 0;
			}
		}
	}
	return 0;
}